#include <wiringPi.h>
#include <iostream>
#include <stdio.h>
#include <sys/time.h>
#include <time.h>
#include <stdlib.h>
#include <sched.h>
#include <sstream>

/*
Par Idleman (idleman@idleman.fr - http://blog.idleman.fr)
Licence : CC by sa
Toutes question sur le blog ou par mail, possibilité de m'envoyer des bières via le blog
*/

using namespace std;


int pin;
bool bit2[26]={};              // 26 bit Identifiant emetteur
bool bit2Interruptor[4]={}; 
bool action=false;
int interruptor;
int sender;
string onoff;

void log(string a){
	//Décommenter pour avoir les logs

	//cout << a << endl;
}




void scheduler_realtime() {

struct sched_param p;
p.__sched_priority = sched_get_priority_max(SCHED_RR);
if( sched_setscheduler( 0, SCHED_RR, &p ) == -1 ) {
perror("Failed to switch to realtime scheduler.");
}
}

void scheduler_standard() {

struct sched_param p;
p.__sched_priority = 0;
if( sched_setscheduler( 0, SCHED_OTHER, &p ) == -1 ) {
perror("Failed to switch to normal scheduler.");
}
}



//Envois d'une pulsation (passage de l'etat haut a l'etat bas)
//1 = 310µs haut puis 1340µs bas
//0 = 310µs haut puis 310µs bas
void sendBit(bool b) {
 if (b) {
   digitalWrite(pin, HIGH);
   delayMicroseconds(490-15-5);   //275 orinally, but tweaked.
   digitalWrite(pin, LOW);
   delayMicroseconds(230-15-20);  //1225 orinally, but tweaked.
 }
 else {
   digitalWrite(pin, HIGH);
   delayMicroseconds(140-15);   //275 orinally, but tweaked.
   digitalWrite(pin, LOW);
   delayMicroseconds(570-15-20-10);   //275 orinally, but tweaked.
 }
}

//Envoie d'une paire de pulsation radio qui definissent 1 bit réel : 0 =01 et 1 =10
//c'est le codage de manchester qui necessite ce petit bouzin, ceci permet entre autres de dissocier les données des parasites
void sendPair(int symbol) {
 if(symbol==1)
 {
   sendBit(true);
   sendBit(true);
   //log("Send pair '1'");
 }
 else if (symbol==0)
 {
   sendBit(false);
   sendBit(false);
   //log("Send pair '0'");
 }
 else //for floating connexion - see PT2260 datasheet
 {
   sendBit(false);
   sendBit(true);
   //log("Send pair 'f'");
 }
}

//Calcul le nombre 2^chiffre indiqué, fonction utilisé par itob pour la conversion decimal/binaire
unsigned long power2(int power){
unsigned long integer=1;
for (int i=0; i<power; i++){
  integer*=2;
}
return integer;
} 

//Convertis un nombre en binaire, nécessite le nombre, et le nombre de bits souhaité en sortie (ici 26)
// Stocke le résultat dans le tableau global "bit2"
void itob(unsigned long integer, int length)
{
	for (int i=0; i<length; i++){
	  if ((integer / power2(length-1-i))==1){
		integer-=power2(length-1-i);
		bit2[i]=1;
	  }
	  else bit2[i]=0;
	}
}

void itobInterruptor(unsigned long integer, int length)
{
	for (int i=0; i<length; i++){
	  if ((integer / power2(length-1-i))==1){
		integer-=power2(length-1-i);
		bit2Interruptor[i]=1;
	  }
	  else bit2Interruptor[i]=0;
	}
}







//Fonction d'envois du signal
//recoit en parametre un booleen définissant l'arret ou la marche du matos (true = on, false = off)
void transmitPT2260(char A0, char A1, char A2, char A3, char A4, char A5, char A6, char A7, char D0, char D1, char D2, char D3)
{
sendPair(A0);
sendPair(A1);
sendPair(A2);
sendPair(A3);
sendPair(A4);
sendPair(A5);
sendPair(A6);
sendPair(A7);
sendPair(D0);
sendPair(D1);
sendPair(D2);
sendPair(D3);
sendBit(false); //synchro
}


void transmitSIPLEC(int code, int prise, bool onoff)
{
  int address = code & 0xFFFF;
  char ad[7];
  char pr[3];
  char st[2];
  
  for (int i=0; i<7; i++)
  {
    if (address & (1 << i))
      ad[i]=0;
    else
      ad[i]=2; //2 is for floating connexion - see PT2260 datasheet
  }
  if (prise == 1)
  {
    pr[0]=1;
    pr[1]=0;
    pr[2]=2;
  }else  if (prise == 2)
  {
    pr[0]=0;
    pr[1]=1;
    pr[2]=2;
  }else  if (prise == 3)
  {
    pr[0]=0;
    pr[1]=0;
    pr[2]=1;
  }else
    log("Num prise != 1, 2 ou 3");
  
  if (onoff)
  {
    st[0]=1;
    st[1]=0;
  }
  else
  {
    st[0]=0;
    st[1]=1;
  }
    
  
  transmitPT2260(ad[0], ad[1], ad[2], ad[3], ad[4], ad[5], ad[6], pr[2], pr[1], pr[0], st[1], st[0]);  

}



int main (int argc, char** argv)
{
if (argc < 5)
{
perror("Il manque un argument!\n Appel : [GPIO] [codetelecommande] [numero prise] [on/off]");
return 1;
}

	if (setuid(0))
	{
		perror("setuid");
		return 1;
	}

	scheduler_realtime();

	log("Demarrage du programme");
	pin = atoi(argv[1]);
	sender = atoi(argv[2]);
	interruptor = atoi(argv[3]);
	onoff = argv[4];
	//Si on ne trouve pas la librairie wiringPI, on arrête l'execution
    if(wiringPiSetup() == -1)
    {
        log("Librairie Wiring PI introuvable, veuillez lier cette librairie...");
        return -1;

    }
    pinMode(pin, OUTPUT);

	log("Pin GPIO configure en sortie");

	delay(100);                 // attendre 10 ms (sinon le socket nous ignore)
	
	if(onoff=="on"){
	  action=true;
	}else if (onoff=="off"){
	  action=false;}
	
	log("envoi du signal");
	 for(int i=0;i<10;i++){
		 transmitSIPLEC(sender%100, interruptor, action);
		 delay(6);                 // attendre 10 ms (sinon le socket nous ignore)
	 }


	 log("fin du programme");    // execution terminée.


	scheduler_standard();
}

