<?php
/*
@name Prises SIPLEC
@author Valentin CARRUESCO & robin5wood <idleman@idleman.fr> 
@link http://robin5wood.free.fr/cms/?Domotique___Commander_des_prises_avec_YANA
@licence CC by nc sa
@version 1.0.2
@description Prises SIPLEC - 433MHz
*/

include('siplec.class.php');



function siplec_plugin_setting_page(){
	global $_,$myUser,$conf;
	if(isset($_['section']) && $_['section']=='siplec' ){

		if($myUser!=false){
			$siplecManager = new siplec();
			$siplecs = $siplecManager->populate();
			$roomManager = new Room();
			$rooms = $roomManager->populate();

			//Si on est en mode modification
			if (isset($_['id'])){
				$id_mod = $_['id'];
				$selected = $siplecManager->getById($id_mod);
				$description = $selected->GetName();
				$button = "Modifier";
			}
			//Si on est en mode ajout
			else
			{
				$description =  "Ajout d'une prise SIPLEC - 433MHz";
				$button = "Ajouter";
			}
			?>

			<div class="span9 userBloc">


				<h1>Prises SIPLEC</h1>
				<p>Gestion des prises SIPLEC - 433MHz</p>  
				<form action="action.php?action=siplec_add_siplec" method="POST">
					<fieldset>
						<legend><?php echo $description ?></legend>

						<div class="left">
							<label for="namesiplec">Nom</label>
							<?php if(isset($selected)){echo '<input type="hidden" name="id" value="'.$id_mod.'">';} ?>
							<input type="text" id="namesiplec" value="<?php if(isset($selected)){echo $selected->getName();} ?>" onkeyup="$('#vocalCommand').html($(this).val());" name="namesiplec" placeholder="Lumiere Canapé…"/>
							<small>Commande vocale associée : "<?php echo $conf->get('VOCAL_ENTITY_NAME'); ?>, allume <span id="vocalCommand"></span>"</small>
							<label for="descriptionsiplec">Description</label>
							<input type="text" value="<?php if(isset($selected)){echo $selected->getDescription();} ?>" name="descriptionsiplec" id="descriptionsiplec" placeholder="Lumière d'ambiance derrière le canapé…" />
							<label for="telecommandeCodesiplec">Code radio de la telecommande</label>
							<input type="text" value="<?php if(isset($selected)){echo $selected->getTelecommandeCode();} ?>" name="telecommandeCodesiplec" id="telecommandeCodesiplec" placeholder="1402,1412,…" />
							<label for="priseCodesiplec">Code radio de la prise</label>
							<input type="text" value="<?php if(isset($selected)){echo $selected->getPriseCode();} ?>" name="priseCodesiplec" id="priseCodesiplec" placeholder="1,2,3" />
							<label for="roomsiplec">Pièce</label>
							<select name="roomsiplec" id="roomsiplec">
								<?php foreach($rooms as $room){ 
									if (isset($selected)){$selected_room = ($selected->getRoom());}
									else{$selected_room = null;}			    		
									?>

									<option <?php if ($selected_room == $room->getId()){echo "selected";} ?> value="<?php echo $room->getId(); ?>"><?php echo $room->getName(); ?></option>
									<?php } ?>
								</select>
							</div>

							<div class="clear"></div>
							<br/><button type="submit" class="btn"><?php echo $button; ?></button>
						</fieldset>
						<br/>
					</form>

					<table class="table table-striped table-bordered table-hover">
						<thead>
							<tr>
								<th>Nom</th>
								<th>Description</th>
								<th>Code télécommande</th>
								<th>Code prise</th>
								<th>Pièce</th>
								<th></th>
							</tr>
						</thead>

						<?php foreach($siplecs as $siplec){ 

							$room = $roomManager->load(array('id'=>$siplec->getRoom())); 
							?>
							<tr>
								<td><?php echo $siplec->getName(); ?></td>
								<td><?php echo $siplec->getDescription(); ?></td>
								<td><?php echo $siplec->getTelecommandeCode(); ?></td>
								<td><?php echo $siplec->getPriseCode(); ?></td>
								<td><?php echo $room->getName(); ?></td>
								<td><a class="btn" href="action.php?action=siplec_delete_siplec&id=<?php echo $siplec->getId(); ?>"><i class="fa fa-times"></i></a>
									<a class="btn" href="setting.php?section=siplec&id=<?php echo $siplec->getId(); ?>"><i class="fa fa-pencil"></i></a></td>
								</tr>
								<?php } ?>
							</table>
						</div>

						<?php }else{ ?>

						<div id="main" class="wrapper clearfix">
							<article>
								<h3>Vous devez être connecté</h3>
							</article>
						</div>
						<?php
					}
				}

			}

			function siplec_plugin_setting_menu(){
				global $_;
				echo '<li '.(isset($_['section']) && $_['section']=='siplec'?'class="active"':'').'><a href="setting.php?section=siplec"><i class="fa fa-angle-right"></i> Prise siplec</a></li>';
			}




			function siplec_display($room){
				global $_;


				$siplecManager = new siplec();
				$siplecs = $siplecManager->loadAll(array('room'=>$room->getId()));

				foreach ($siplecs as $siplec) {

					?>

<div class="flatBloc orange-color" style="max-width:30%;display:inline-block;vertical-align:top;">
						<h3><?php echo $siplec->getName() ?></h3>	
						<p><?php echo $siplec->getDescription() ?></p><ul>
						<li>Code radio : <code><?php echo $siplec->getTelecommandeCode().' '.$siplec->getPriseCode() ?></code></li>
						<li>Type : <span>Prise commandee SIPLEC</span></li>
						<li>Emplacement : <span><?php echo $room->getName() ?></span></li>
					</ul>
				<?php  if(fileperms(Plugin::path().'radioEmission')!='36333'){ ?><div class="flatBloc pink-color">Attention, les droits vers le fichier <br/> radioEmission sont mal réglés.<br/> Référez vous à <span style="cursor:pointer;text-decoration:underline;" onclick="window.location.href='https://github.com/ldleman/yana-server#installation';">la doc</span> pour les régler</div><?php } ?>
					
					<a class="flatBloc" title="Activer le relais" href="action.php?action=siplec_change_state&engine=<?php echo $siplec->getId() ?>&amp;telecommande=<?php echo $siplec->getTelecommandeCode() ?>&amp;prise=<?php echo $siplec->getPriseCode() ?>&amp;state=on"><i class="fa fa-hand-o-up icon-white"></i></a>
					
					<a class="flatBloc" title="Désactiver le relais" href="action.php?action=siplec_change_state&engine=<?php echo $siplec->getId() ?>&amp;telecommande=<?php echo $siplec->getTelecommandeCode() ?>&amp;prise=<?php echo $siplec->getPriseCode() ?>&amp;state=off"><i class="fa fa-hand-o-down icon-white"></i></a>
						
					
					
					
					
					
					
					
					
				</div>
				
				
				
				<?php
			}
		}

		function siplec_vocal_command(&$response,$actionUrl){
			global $conf;
			$siplecManager = new siplec();

			$siplecs = $siplecManager->populate();
			foreach($siplecs as $siplec){
				$response['commands'][] = array('command'=>$conf->get('VOCAL_ENTITY_NAME').', allume '.$siplec->getName(),'url'=>$actionUrl.'?action=siplec_change_state&engine='.$siplec->getId().'&state=on&webservice=true','confidence'=>'0.9');
				$response['commands'][] = array('command'=>$conf->get('VOCAL_ENTITY_NAME').', eteint '.$siplec->getName(),'url'=>$actionUrl.'?action=siplec_change_state&engine='.$siplec->getId().'&state=off&webservice=true','confidence'=>'0.9');
			}
		}

		function siplec_action_siplec(){
			global $_,$conf,$myUser,$conf;

	//Mise à jour des droits
			$myUser->loadRight();

			switch($_['action']){
				case 'siplec_delete_siplec':
//				if($myUser->can('radio relais','d')){
				if($myUser->can('Prises SIPLEC','d')){
					$siplecManager = new siplec();
					$siplecManager->delete(array('id'=>$_['id']));
					header('location:setting.php?section=siplec');
				}
				else
				{
					header('location:setting.php?section=siplec&error=Vous n\'avez pas le droit de faire ça!');
				}

				break;
				case 'siplec_plugin_setting':
				$conf->put('plugin_433MHz_emitter_pin',$_['emiterPin']);
				header('location: setting.php?section=preference&block=siplec');
				break;

				case 'siplec_add_siplec':

				//Vérifie si on veut modifier ou ajouter un relai
				$right_toverify = isset($_['id']) ? 'u' : 'c';

//				if($myUser->can('radio relais',$right_toverify)){
				if($myUser->can('Prises SIPLEC',$right_toverify)){
					$siplec = new siplec();
					//Si modification on charge la ligne au lieu de la créer
					if ($right_toverify == "u"){$siplec = $siplec->load(array("id"=>$_['id']));}
					$siplec->setName($_['namesiplec']);
					$siplec->setDescription($_['descriptionsiplec']);
					$siplec->setTelecommandeCode($_['telecommandeCodesiplec']);
					$siplec->setPriseCode($_['priseCodesiplec']);
					$siplec->setRoom($_['roomsiplec']);
					$siplec->save();
					header('location:setting.php?section=siplec');
				}
				else
				{
					header('location:setting.php?section=siplec&error=Vous n\'avez pas le droit de faire ça!');
				}


				break;

				case 'siplec_change_state':
				global $_,$myUser,$conf;


				if($myUser->can('Prises SIPLEC','u')){
					$siplec = new siplec();
					$siplec = $siplec->getById($_['engine']);
					$cmd = dirname(__FILE__).'/radioEmission '.$conf->get('plugin_433MHz_emitter_pin').' '.$siplec->getTelecommandeCode().' '.$siplec->getPriseCode().' '.$_['state'];

				//TODO change bdd state
					system($cmd,$out);
					if(!isset($_['webservice'])){
						header('location:index.php?module=room&id='.$siplec->getRoom());
					}else{
						$affirmations = array(	'A vos ordres!',
							'Bien!',
							'Oui commandant!',
							'Avec plaisir!',
							'J\'aime vous obéir!',
							'Avec plaisir!',
							'Certainement!',
							'Je fais ça sans tarder!',
							'Avec plaisir!',
							'Oui chef!');
						$affirmation = $affirmations[rand(0,count($affirmations)-1)];
						$response = array('responses'=>array(
							array('type'=>'talk','sentence'=>$affirmation)
							)
						);

						$json = json_encode($response);
						echo ($json=='[]'?'{}':$json);
					}
				}else{
					$response = array('responses'=>array(
						array('type'=>'talk','sentence'=>'Je ne vous connais pas, je refuse de faire ça!')
						)
					);
					echo json_encode($response);
				}
				break;
			}
		}


		function siplec_plugin_preference_menu(){
			global $_;
			echo '<li '.(@$_['block']=='siplec'?'class="active"':'').'><a  href="setting.php?section=preference&block=siplec"><i class="icon-chevron-right"></i> Prise siplec</a></li>';
		}
		function siplec_plugin_preference_page(){
			global $myUser,$_,$conf;
			if((isset($_['section']) && $_['section']=='preference' && @$_['block']=='siplec' )  ){
				if($myUser!=false){
					?>

					<div class="span9 userBloc">
						<form class="form-inline" action="action.php?action=siplec_plugin_setting" method="POST">

							<p>Pin du raspberry PI branché à l'émetteur radio: </p>
							<input type="text" class="input-large" name="emiterPin" value="<?php echo $conf->get('plugin_433MHz_emitter_pin');?>" placeholder="Pin wiring PI...">

							<button type="submit" class="btn">Enregistrer</button>
						</form>
					</div>

					<?php }else{ ?>

					<div id="main" class="wrapper clearfix">
						<article>
							<h3>Vous devez être connecté</h3>
						</article>
					</div>
					<?php

				}
			}
		}


		Plugin::addHook("preference_menu", "siplec_plugin_preference_menu"); 
		Plugin::addHook("preference_content", "siplec_plugin_preference_page"); 

		Plugin::addCss("/css/style.css"); 
		Plugin::addHook("action_post_case", "siplec_action_siplec"); 

		Plugin::addHook("node_display", "siplec_display");   
		Plugin::addHook("setting_bloc", "siplec_plugin_setting_page");
		Plugin::addHook("setting_menu", "siplec_plugin_setting_menu");  
		Plugin::addHook("vocal_command", "siplec_vocal_command");
		?>
